'############################ REPLY ############################
'George Bleck, Member
'posted April 27, 2003 07:42 PM

'POFFS database analyzer
'Public Domain
'George W. Bleck

'----------------------------------------------------------------------------(')

#COMPILE EXE "whenon.exe"
#DIM ALL
#REGISTER NONE

'----------------------------------------------------------------------------(')

$TempFileName = "WhenOn.TMP"
$EnvironToCheck = "TEMP"

'----------------------------------------------------------------------------(')

%TRUE = 1
%FALSE = 0
%NULL = 0
%WM_USER = &H400
%SRCCOPY = &H00CC0020        ' (DWORD) dest = source
%LTGRAY_BRUSH = 1
%WM_DESTROY = &H2
%WM_PAINT = &HF
%WM_NOTIFY = &H4E
%WM_INITDIALOG = &H110
%WM_COMMAND = &H111
%WS_POPUP = &H80000000
%WS_CHILD = &H40000000
%WS_VISIBLE = &H10000000
%WS_DISABLED = &H08000000
%WS_CLIPSIBLINGS = &H04000000
%WS_CAPTION = &H00C00000        ' WS_BORDER OR WS_DLGFRAME
%WS_BORDER = &H00800000
%WS_DLGFRAME = &H00400000
%WS_SYSMENU = &H00080000
%WS_TABSTOP = &H00010000
%WS_MINIMIZEBOX = &H00020000
%WS_EX_WINDOWEDGE = &H00000100
%WS_EX_CLIENTEDGE = &H00000200
%WS_EX_LEFT = &H00000000
%WS_EX_LTRREADING = &H00000000
%WS_EX_RIGHTSCROLLBAR = &H00000000
%WS_EX_CONTROLPARENT = &H00010000
%WS_EX_STATICEDGE = &H00020000
%HWND_DESKTOP = 0
%ES_LEFT = &H0&
%ES_AUTOHSCROLL = &H80&
%ES_READONLY = &H800&
%BS_TEXT = &H0&
%BS_PUSHBUTTON = &H0&
%BS_CENTER = &H300&
%BS_VCENTER = &HC00&
%BN_CLICKED = 0
%SS_LEFT = &H00000000
%SS_CENTERIMAGE = &H00000200
%DS_3DLOOK = &H0004&
%DS_NOFAILCREATE = &H0010&
%DS_SETFONT = &H0040&        ' User specified font for Dlg controls
%DS_MODALFRAME = &H0080&        ' Can be combined with WS_CAPTION
%DS_CENTER = &H0800&
%LVM_FIRST = &H1000        ' ListView messages
%LVN_FIRST = 0 - 100        ' listview
%LVS_REPORT = &H00000001
%LVS_SINGLESEL = &H00000004
%LVS_SHOWSELALWAYS = &H00000008
%LVM_GETITEMCOUNT = %LVM_FIRST + 4
%LVIF_TEXT = &H0001
%LVIF_PARAM = &H0004
%LVM_SETITEM = %LVM_FIRST + 6
%LVM_INSERTITEM = %LVM_FIRST + 7
%LVNI_SELECTED = &H0002
%LVM_GETNEXTITEM = %LVM_FIRST + 12
%LVFI_PARAM = &H0001
%LVM_FINDITEM = %LVM_FIRST + 13
%LVCF_FMT = &H0001
%LVCF_TEXT = &H0004
%LVCF_SUBITEM = &H0008
%LVCFMT_LEFT = &H00000000
%LVCFMT_RIGHT = &H00000001
%LVM_INSERTCOLUMN = %LVM_FIRST + 27
%LVSCW_AUTOSIZE = - 1
%LVSCW_AUTOSIZE_USEHEADER = - 2
%LVM_SETCOLUMNWIDTH = %LVM_FIRST + 30
%LVM_GETITEMTEXT = ( %LVM_FIRST + 45 )
%LVM_SORTITEMS = %LVM_FIRST + 48
%LVM_SETEXTENDEDLISTVIEWSTYLE = %LVM_FIRST + 54        ' optional wParam == mask
%LVM_GETEXTENDEDLISTVIEWSTYLE = %LVM_FIRST + 55
%LVS_EX_GRIDLINES = &H00000001
%LVS_EX_FULLROWSELECT = &H00000020        ' applies to report mode only
%LVN_ITEMCHANGED = %LVN_FIRST - 1
%LVN_COLUMNCLICK = %LVN_FIRST - 8

'----------------------------------------------------------------------------(')

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE

'----------------------------------------------------------------------------(')

TYPE POINTAPI
    x AS LONG
    y AS LONG
END TYPE

'----------------------------------------------------------------------------(')

TYPE PAINTSTRUCT
    hDC AS DWORD
    fErase AS LONG
    rcPaint AS RECT
    fRestore AS LONG
    fIncUpdate AS LONG
    rgbReserved( 0 TO 31 ) AS BYTE
END TYPE

'----------------------------------------------------------------------------(')

TYPE NMHDR
    hwndFrom AS DWORD
    idfrom AS DWORD
    code AS LONG        ' used for messages, so needs to be LONG, not DWORD...
END TYPE

'----------------------------------------------------------------------------(')

TYPE LV_ITEM
    mask AS DWORD
    iItem AS LONG
    iSubItem AS LONG
    STATE AS DWORD
    stateMask AS DWORD
    pszText AS ASCIIZ PTR
    cchTextMax AS LONG
    iImage AS LONG
    lParam AS LONG
    iIndent AS LONG
    iGroupId AS LONG
    cColumns AS DWORD        ' tile view columns
    puColumns AS DWORD PTR
END TYPE

'----------------------------------------------------------------------------(')

TYPE LV_FINDINFO
    flags AS DWORD
    psz AS ASCIIZ PTR
    lParam AS LONG
    pt AS POINTAPI
    vkDirection AS DWORD
END TYPE

'----------------------------------------------------------------------------(')

TYPE LV_COLUMN
    mask AS DWORD
    fmt AS LONG
    cx AS LONG
    pszText AS ASCIIZ PTR
    cchTextMax AS LONG
    iSubItem AS LONG
    iImage AS LONG
    iOrder AS LONG
END TYPE

'----------------------------------------------------------------------------(')

TYPE NM_LISTVIEW
    hdr AS NMHDR
    iItem AS LONG
    iSubItem AS LONG
    uNewState AS DWORD
    uOldState AS DWORD
    uChanged AS DWORD
    ptAction AS POINTAPI
    lParam AS LONG
END TYPE

'----------------------------------------------------------------------------(')

DECLARE FUNCTION BEGINPAINT LIB "USER32.DLL" ALIAS "BeginPaint" ( BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT ) AS LONG
DECLARE FUNCTION BITBLT LIB "GDI32.DLL" ALIAS "BitBlt" ( BYVAL hDestDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS DWORD, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, _
  BYVAL dwRop AS DWORD ) AS LONG
DECLARE FUNCTION CREATECOMPATIBLEBITMAP LIB "GDI32.DLL" ALIAS "CreateCompatibleBitmap" ( BYVAL hdc AS DWORD, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG ) AS DWORD
DECLARE FUNCTION CREATECOMPATIBLEDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" ( BYVAL hdc AS DWORD ) AS DWORD
DECLARE FUNCTION DELETEDC LIB "GDI32.DLL" ALIAS "DeleteDC" ( BYVAL hdc AS DWORD ) AS LONG
DECLARE FUNCTION DELETEOBJECT LIB "GDI32.DLL" ALIAS "DeleteObject" ( BYVAL hObject AS DWORD ) AS LONG
DECLARE FUNCTION ENDPAINT LIB "USER32.DLL" ALIAS "EndPaint" ( BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT ) AS LONG
DECLARE FUNCTION FILLRECT LIB "USER32.DLL" ALIAS "FillRect" ( BYVAL hDC AS DWORD, lpRect AS RECT, BYVAL hBrush AS DWORD ) AS LONG
DECLARE FUNCTION GETDC LIB "USER32.DLL" ALIAS "GetDC" ( BYVAL hWnd AS DWORD ) AS DWORD
DECLARE FUNCTION GETSTOCKOBJECT LIB "GDI32.DLL" ALIAS "GetStockObject" ( BYVAL nIndex AS LONG ) AS DWORD
DECLARE FUNCTION INVALIDATERECT LIB "USER32.DLL" ALIAS "InvalidateRect" ( BYVAL hWnd AS DWORD, lpRect AS RECT, BYVAL bErase AS LONG ) AS LONG
DECLARE FUNCTION RECTANGLE LIB "GDI32.DLL" ALIAS "Rectangle" ( BYVAL hdc AS DWORD, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG ) AS LONG
DECLARE FUNCTION RELEASEDC LIB "USER32.DLL" ALIAS "ReleaseDC" ( BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD ) AS LONG
DECLARE FUNCTION SELECTOBJECT LIB "GDI32.DLL" ALIAS "SelectObject" ( BYVAL hdc AS DWORD, BYVAL hObject AS DWORD ) AS DWORD
DECLARE FUNCTION SENDMESSAGE LIB "USER32.DLL" ALIAS "SendMessageA" ( BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG ) AS LONG
DECLARE FUNCTION UPDATEWINDOW LIB "USER32.DLL" ALIAS "UpdateWindow" ( BYVAL hWnd AS DWORD ) AS LONG
DECLARE SUB INITCOMMONCONTROLS LIB "COMCTL32.DLL" ALIAS "InitCommonControls" ( )
DECLARE FUNCTION ListView_GetNextItem( BYVAL hWnd AS DWORD, BYVAL i AS LONG, BYVAL flags AS LONG ) AS LONG
DECLARE FUNCTION ListView_FindItem( BYVAL hWnd AS DWORD, BYVAL iStart AS LONG, plvfi AS LV_FINDINFO ) AS LONG
DECLARE FUNCTION ListView_InsertColumn( BYVAL hWnd AS DWORD, BYVAL iCol AS LONG, pcol AS LV_COLUMN ) AS LONG
DECLARE FUNCTION ListView_SetColumnWidth( BYVAL hWnd AS DWORD, BYVAL iCol AS LONG, BYVAL cx AS INTEGER ) AS LONG
DECLARE FUNCTION ListView_SortItems( BYVAL hWndLV AS DWORD, _
  BYVAL pfnCompare AS DWORD, BYVAL lPrm AS LONG ) AS LONG
DECLARE FUNCTION ListView_SetExtendedListViewStyle( BYVAL hwndLV AS DWORD, _
  BYVAL dw AS DWORD ) AS DWORD
DECLARE FUNCTION ListView_GetExtendedListViewStyle( BYVAL hwndLV AS DWORD ) AS DWORD

'----------------------------------------------------------------------------(')

FUNCTION ListView_GetNextItem( BYVAL hWnd AS DWORD, BYVAL i AS LONG, BYVAL flags AS LONG ) AS LONG
    FUNCTION = SENDMESSAGE( hWnd, %LVM_GETNEXTITEM, i, MAKLNG( flags, 0 ))
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION ListView_FindItem( BYVAL hWnd AS DWORD, BYVAL iStart AS LONG, plvfi AS LV_FINDINFO ) AS LONG
    FUNCTION = SENDMESSAGE( hWnd, %LVM_FINDITEM, iStart, VARPTR( plvfi ))
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION ListView_InsertColumn( BYVAL hWnd AS DWORD, BYVAL iCol AS LONG, pcol AS LV_COLUMN ) AS LONG
    FUNCTION = SENDMESSAGE( hWnd, %LVM_INSERTCOLUMN, iCol, VARPTR( pcol ))
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION ListView_SetColumnWidth( BYVAL hWnd AS DWORD, BYVAL iCol AS LONG, BYVAL cx AS INTEGER ) AS LONG
    FUNCTION = SENDMESSAGE( hWnd, %LVM_SETCOLUMNWIDTH, iCol, MAKLNG( cx, 0 ))
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION ListView_SortItems( BYVAL hWndLV AS DWORD, _
      BYVAL pfnCompare AS DWORD, BYVAL lPrm AS LONG ) AS LONG
    FUNCTION = SENDMESSAGE( hWndLV, %LVM_SORTITEMS, lPrm, pfnCompare )
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION ListView_SetExtendedListViewStyle( BYVAL hwndLV AS DWORD, _
      BYVAL dw AS DWORD ) AS DWORD
    FUNCTION = SENDMESSAGE( hwndLV, %LVM_SETEXTENDEDLISTVIEWSTYLE, 0, dw )
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION ListView_GetExtendedListViewStyle( BYVAL hwndLV AS DWORD ) AS DWORD
    FUNCTION = SENDMESSAGE( hwndLV, %LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0 )
END FUNCTION

'----------------------------------------------------------------------------(')

DECLARE SUB ListView_GetItemText( BYVAL hWndLV AS DWORD, BYVAL i AS LONG, _
  BYVAL iSubItem AS LONG, pszText AS ASCIIZ, BYVAL cchTextMax AS LONG )

'----------------------------------------------------------------------------(')

SUB ListView_GetItemText( BYVAL hWndLV AS DWORD, BYVAL i AS LONG, _
      BYVAL iSubItem AS LONG, pszText AS ASCIIZ, BYVAL cchTextMax AS LONG )
    LOCAL ms_lvi AS LV_ITEM
    ms_lvi.iSubItem = iSubItem
    ms_lvi.cchTextMax = cchTextMax
    ms_lvi.pszText = VARPTR( pszText )
    SENDMESSAGE hWndLV, %LVM_GETITEMTEXT, i, VARPTR( ms_lvi )
END SUB

'----------------------------------------------------------------------------(')

TYPE PostingArrayType
    strName AS STRING * 32
    lngDate AS LONG
    lngTime AS LONG
END TYPE

'----------------------------------------------------------------------------(')

GLOBAL gudtPostingArray( ) AS PostingArrayType
GLOBAL glngArrayIndex AS LONG
GLOBAL gboolExitFlag AS LONG
GLOBAL gstrForumFile AS STRING
GLOBAL ghDCGraph1 AS DWORD
GLOBAL ghBmpGraph1 AS DWORD
GLOBAL ghDCGraph2 AS DWORD
GLOBAL ghBmpGraph2 AS DWORD
GLOBAL ghDlg AS DWORD
GLOBAL ghListview AS DWORD
GLOBAL glngLVSortDirection AS LONG

'----------------------------------------------------------------------------(')

%btnAnalyze = 1001
%btnExit = 1002
%dlgMain = 1003
%edtIndex = 1004
%edtName = 1005
%edtTotalPosts = 1006
%frameDayOfWeekUsageGraph = 1007
%frameTimeOfDayUsageGraph = 1008
%frameUserInformation = 1009
%lvwNames = 1010
%staticIndex = 1011
%staticName = 1012
%staticStatus = 1013
%staticTotalPosts = 1014

'----------------------------------------------------------------------------(')

DECLARE CALLBACK FUNCTION dlgMainCallback( )
DECLARE FUNCTION GD2JD( lngYear AS LONG, lngMonth AS LONG, lngDay AS LONG ) AS LONG
DECLARE FUNCTION LV_Compare( BYVAL lParam1 AS LONG, BYVAL lParam2 AS LONG, BYVAL lParamsort AS LONG ) AS INTEGER
DECLARE FUNCTION LV_ReadItem( BYVAL lngIndex AS LONG, BYVAL lngColumn AS LONG ) AS STRING
DECLARE FUNCTION LV_SetColumnHeadings( strColumn1Heading AS STRING, strColumn2Heading AS STRING, strColumn3Heading AS STRING ) AS DWORD
DECLARE FUNCTION PBMAIN( )
DECLARE FUNCTION ProcessFiles( BYVAL lngDummy AS LONG ) AS LONG
DECLARE SUB AddToArray( strName AS STRING, lngDate AS LONG, lngTime AS LONG )
DECLARE SUB CvtDate( strDate AS STRING, lngDate AS LONG, lngTime AS LONG )
DECLARE SUB LV_AddItem( strName AS STRING, lngPostCount AS LONG )
DECLARE SUB MakeGraphs( strName AS STRING )

'----------------------------------------------------------------------------(')

FUNCTION LV_SetColumnHeadings( strColumn1Heading AS STRING, strColumn2Heading AS STRING, strColumn3Heading AS STRING ) AS DWORD
    LOCAL lngStyle AS LONG
    LOCAL structLVColumn AS LV_COLUMN
    lngStyle = ListView_GetExtendedListViewStyle( ghListview )
    CALL ListView_SetExtendedListViewStyle( ghListview, lngStyle OR %LVS_EX_FULLROWSELECT OR %LVS_EX_GRIDLINES )
    'Load column headers.
    structLVColumn.mask = %LVCF_FMT OR %LVCF_TEXT OR %LVCF_SUBITEM
    structLVColumn.fmt = %LVCFMT_LEFT
    structLVColumn.pszText = STRPTR( strColumn1Heading )
    CALL ListView_InsertColumn( ghListview, 0, structLVColumn )
    structLVColumn.fmt = %LVCFMT_RIGHT
    structLVColumn.pszText = STRPTR( strColumn2Heading )
    CALL ListView_InsertColumn( ghListview, 1, structLVColumn )
    structLVColumn.pszText = STRPTR( strColumn3Heading )
    CALL ListView_InsertColumn( ghListview, 2, structLVColumn )
    CALL ListView_SetColumnWidth( ghListview, 0, %LVSCW_AUTOSIZE_USEHEADER )
    CALL ListView_SetColumnWidth( ghListview, 1, %LVSCW_AUTOSIZE_USEHEADER )
    CALL ListView_SetColumnWidth( ghListview, 2, %LVSCW_AUTOSIZE_USEHEADER )
END FUNCTION

'----------------------------------------------------------------------------(')

SUB LV_AddItem( strName AS STRING, lngPostCount AS LONG )
    LOCAL udtLVItem AS LV_ITEM
    LOCAL dwdIndex AS DWORD
    LOCAL strText AS STRING
    STATIC lngCounter AS LONG
    INCR lngCounter
    'Set the name column
    udtLVItem.mask = %LVIF_TEXT OR %LVIF_PARAM
    udtLVItem.lParam = lngCounter
    udtLVItem.pszText = STRPTR( strName )
    dwdIndex = SENDMESSAGE( ghListview, %LVM_INSERTITEM, 0, VARPTR( udtLVItem ))
    'Set the Post count Column
    udtLVItem.iItem = dwdIndex
    udtLVItem.mask = %LVIF_TEXT
    udtLVItem.iSubItem = 1
    strText = FORMAT$( lngPostCount, "###,###,###" )
    udtLVItem.pszText = STRPTR( strText )
    CALL SENDMESSAGE( ghListview, %LVM_SETITEM, 0, VARPTR( udtLVItem ))
    'Set the Percentage Column
    udtLVItem.iItem = dwdIndex
    udtLVItem.mask = %LVIF_TEXT
    udtLVItem.iSubItem = 2
    strText = FORMAT$( lngPostCount / glngArrayIndex * 100, "##.00" )
    udtLVItem.pszText = STRPTR( strText )
    CALL SENDMESSAGE( ghListview, %LVM_SETITEM, 0, VARPTR( udtLVItem ))
END SUB

'----------------------------------------------------------------------------(')

FUNCTION LV_ReadItem( BYVAL lngIndex AS LONG, BYVAL lngColumn AS LONG ) AS STRING
    LOCAL aszText AS ASCIIZ * 256
    CALL ListView_GetItemText( ghListview, lngIndex, lngColumn, aszText, SIZEOF( aszText ))
    FUNCTION = aszText
END FUNCTION

'----------------------------------------------------------------------------(')

SUB MakeGraphs( strName AS STRING )
    'box1 250,130 - 520, 210
    'box1 250,253 - 520, 333
    DIM lngDays( 6 ) AS LONG
    DIM lngTime( 47 ) AS LONG
    LOCAL lngIndex AS LONG
    LOCAL lngLargestDay AS LONG
    LOCAL lngLargestTime AS LONG
    LOCAL lngScaleWidth AS LONG
    LOCAL udtRect AS RECT
    'Set up the graphing environment (origins and dimensions)
    udtRect.nLeft = 0
    udtRect.nTop = 0
    udtRect.nRight = 270
    udtRect.nBottom = 80
    'Collate the graph data and find scaling factors
    lngIndex = 0
    IF strName <> "" THEN
        DO UNTIL TRIM$( gudtPostingArray( lngIndex ).strName ) = strName OR lngIndex > glngArrayIndex
            INCR lngIndex
        LOOP
    END IF
    DO UNTIL( TRIM$( gudtPostingArray( lngIndex ).strName ) <> strName AND strName <> "" ) OR lngIndex > glngArrayIndex
        INCR lngDays( gudtPostingArray( lngIndex ).lngDate MOD 7 )
        INCR lngTime( ROUND( gudtPostingArray( lngIndex ).lngTime / ( 1439 / UBOUND( lngTime )), 0 ))
        INCR lngIndex
    LOOP
    'Find scaling factor
    FOR lngIndex = 0 TO 6
        IF lngLargestDay < lngDays( lngIndex ) THEN lngLargestDay = lngDays( lngIndex )
    NEXT lngIndex
    FOR lngIndex = 0 TO UBOUND( lngTime )
        IF lngLargestTime < lngTime( lngIndex ) THEN lngLargestTime = lngTime( lngIndex )
    NEXT lngIndex
    'Draw the day of week graph
    CALL FILLRECT( ghDCGraph1, udtRect, GETSTOCKOBJECT( %LTGRAY_BRUSH ))
    lngScaleWidth = udtRect.nRight / 7
    FOR lngIndex = 0 TO 6
        CALL RECTANGLE ghDCGraph1, _
          udtRect.nLeft + lngIndex * ( lngScaleWidth ), _
          udtRect.nTop + udtRect.nBottom, _
          udtRect.nLeft + lngIndex * ( lngScaleWidth ) + ( lngScaleWidth ) - 1, _
          udtRect.nTop + udtRect.nBottom - ( udtRect.nBottom * ( lngDays( lngIndex ) / lngLargestDay ))
        CALL RECTANGLE ghDCGraph1, _
          udtRect.nLeft + lngIndex * ( lngScaleWidth ), _
          udtRect.nTop + udtRect.nBottom, _
          udtRect.nLeft + lngIndex * ( lngScaleWidth ) + ( lngScaleWidth ) - 1, _
          udtRect.nTop + udtRect.nBottom - 1
    NEXT lngIndex
    'Draw the time of day graph
    CALL FILLRECT( ghDCGraph2, udtRect, GETSTOCKOBJECT( %LTGRAY_BRUSH ))
    lngScaleWidth = udtRect.nRight / UBOUND( lngTime ) - 1
    udtRect.nLeft = udtRect.nLeft + INT( udtRect.nRight / 2 ) - ( lngScaleWidth * INT( UBOUND( lngTime ) / 2 ))
    FOR lngIndex = 0 TO UBOUND( lngTime )
        CALL RECTANGLE ghDCGraph2, _
          udtRect.nLeft + ( lngIndex * lngScaleWidth ), _
          udtRect.nTop + udtRect.nBottom, _
          udtRect.nLeft + ( lngIndex * lngScaleWidth ) + ( lngScaleWidth ) - 1, _
          udtRect.nTop + udtRect.nBottom - ( udtRect.nBottom * ( lngTime( lngIndex ) / lngLargestTime ))
        CALL RECTANGLE ghDCGraph2, _
          udtRect.nLeft + ( lngIndex * lngScaleWidth ), _
          udtRect.nTop + udtRect.nBottom, _
          udtRect.nLeft + ( lngIndex * lngScaleWidth ) + ( lngScaleWidth ) - 1, _
          udtRect.nTop + udtRect.nBottom - 1
    NEXT lngIndex
    INVALIDATERECT ghDlg, BYVAL %NULL, %TRUE
    UPDATEWINDOW ghDlg
END SUB

'----------------------------------------------------------------------------(')

CALLBACK FUNCTION dlgMainCallback( )
    LOCAL hThread AS DWORD
    LOCAL lngResult AS LONG
    LOCAL lngIndex AS LONG
    LOCAL strName AS STRING
    LOCAL lngPostCounter AS LONG
    LOCAL strPosts AS STRING
    LOCAL udtNMListview AS NM_LISTVIEW PTR
    LOCAL hDC AS DWORD
    LOCAL udtPaintStruct AS PAINTSTRUCT
    STATIC lngPrevColumnSelection AS LONG
    SELECT CASE CBMSG
        CASE %WM_INITDIALOG
            lngPrevColumnSelection = 0
            glngLVSortDirection = 0
            CONTROL HANDLE ghDlg, %lvwNames TO ghListview
            CALL INITCOMMONCONTROLS
            CALL LV_SetColumnHeadings( "User Name", "Posts", "Percent" )
            gboolExitFlag = %FALSE
            THREAD CREATE ProcessFiles( ghDlg ) TO hThread
            THREAD CLOSE hThread TO lngResult
            hDC = GETDC( ghDlg )
            ghDCGraph1 = CREATECOMPATIBLEDC( hDC )
            ghBmpGraph1 = CREATECOMPATIBLEBITMAP( hDC, 270, 80 )
            CALL SELECTOBJECT( ghDCGraph1, ghBmpGraph1 )
            ghDCGraph2 = CREATECOMPATIBLEDC( hDC )
            ghBmpGraph2 = CREATECOMPATIBLEBITMAP( hDC, 270, 80 )
            CALL SELECTOBJECT( ghDCGraph2, ghBmpGraph2 )
            CALL RELEASEDC( ghDlg, hDC )
        CASE %WM_COMMAND
            SELECT CASE CBCTL
                CASE %btnAnalyze
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        CONTROL SET TEXT ghDlg, %edtName, " All Users"
                        CONTROL SET TEXT ghDlg, %edtTotalPosts, FORMAT$( glngArrayIndex, " ###,###,###" )
                        CONTROL SET TEXT ghDlg, %edtIndex, " N/A"
                        CALL MakeGraphs( strName )
                    END IF
                CASE %btnExit
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        gboolExitFlag = %TRUE
                        DIALOG END ghDlg
                    END IF
            END SELECT
        CASE %WM_NOTIFY
            'Init NMH pointer.
            udtNMListview = CBLPARAM
            'Examine .Code member.
            SELECT CASE @udtNMListview.hdr.Code
                CASE %LVN_ITEMCHANGED
                    IF @udtNMListview.hdr.idFrom = %lvwNames THEN
                        lngIndex = ListView_GetNextItem( ghListview, - 1, %LVNI_SELECTED )
                        strName = LV_ReadItem( lngIndex, 0 )
                        IF strName <> "" THEN
                            strPosts = LV_ReadItem( ListView_GetNextItem( ghListview, - 1, %LVNI_SELECTED ), 1 )
                            CONTROL SET TEXT ghDlg, %edtName, " " & strName
                            CONTROL SET TEXT ghDlg, %edtTotalPosts, " " & strPosts
                            CONTROL SET TEXT ghDlg, %edtIndex, FORMAT$( lngIndex + 1, " ###,###,###" )
                            CALL MakeGraphs( strName )
                        END IF
                    END IF
                CASE %LVN_COLUMNCLICK
                    IF @udtNMListview.isubItem = 2 THEN @udtNMListview.isubItem = 1
                    IF @udtNMListview.isubItem = lngPrevColumnSelection THEN
                        glngLVSortDirection = NOT glngLVSortDirection
                    ELSE
                        glngLVSortDirection = 0
                        lngPrevColumnSelection = @udtNMListview.isubItem
                    END IF
                    CALL ListView_SortItems( ghListView, CODEPTR( LV_Compare ), @udtNMListview.isubItem )
            END SELECT
        CASE %WM_USER + 1
            lngPostCounter = 1
            FOR lngIndex = 1 TO glngArrayIndex
                IF gudtPostingArray( lngIndex ).strName <> gudtPostingArray( lngIndex - 1 ).strName THEN
                    CALL LV_AddItem( TRIM$( gudtPostingArray( lngIndex - 1 ).strName ), lngPostCounter )
                    lngPostCounter = 1
                ELSE
                    INCR lngPostCounter
                END IF
            NEXT lngIndex
            CALL LV_AddItem( TRIM$( gudtPostingArray( glngArrayIndex ).strName ), lngPostCounter )
            CALL ListView_SetColumnWidth( ghListview, 0, %LVSCW_AUTOSIZE )
            CALL ListView_SetColumnWidth( ghListview, 1, %LVSCW_AUTOSIZE )
            CALL ListView_SetColumnWidth( ghListview, 2, %LVSCW_AUTOSIZE_USEHEADER )
            CONTROL SET TEXT CBHNDL, %staticStatus, _
              " Total Users:  " & FORMAT$( SENDMESSAGE( ghListview, %LVM_GETITEMCOUNT, 0, 0 ), "###,###,###     " ) & _
              " Total Posts:  " & FORMAT$( glngArrayIndex, "###,###,###" )
            CONTROL ENABLE CBHNDL, %lvwNames
            CONTROL ENABLE CBHNDL, %btnAnalyze
        CASE %WM_USER + 2
            SELECT CASE CBWPARAM
                CASE 0
                    CONTROL SET TEXT ghDlg, %staticStatus, " Copying:  " & gstrForumFile
                CASE 1
                    CONTROL SET TEXT ghDlg, %staticStatus, _
                      " Processing:  " & gstrForumFile & FORMAT$( glngArrayIndex, "  ( ###,###,### )" )
            END SELECT
        CASE %WM_PAINT
            hDC = BEGINPAINT( ghDlg, udtPaintStruct )
            BITBLT hDC, 250, 130, 520, 210, ghDCGraph1, 0, 0, %SRCCOPY
            BITBLT hDC, 250, 253, 520, 333, ghDCGraph2, 0, 0, %SRCCOPY
            CALL ENDPAINT( ghDlg, udtPaintStruct )
        CASE %WM_DESTROY
            CALL DELETEOBJECT ghBmpGraph1
            CALL DELETEOBJECT ghBmpGraph2
            CALL DELETEDC ghDCGraph1
            CALL DELETEDC ghDCGraph2
    END SELECT
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION PBMAIN( )
    LOCAL lngResult AS LONG
    global PoffsSourceDir$
    
    PoffsSourceDir$ = CURDIR$ + "\"        'change this to your POFFS directory, ending "\" is required
    
    DIALOG NEW %HWND_DESKTOP, "WhenOn", 154, 102, 364, 247, %WS_POPUP OR %WS_BORDER OR %WS_DLGFRAME OR %WS_CAPTION OR %WS_SYSMENU OR %WS_MINIMIZEBOX OR %WS_CLIPSIBLINGS OR %WS_VISIBLE OR %DS_MODALFRAME OR %DS_CENTER OR %DS_3DLOOK OR _
      %DS_NOFAILCREATE OR %DS_SETFONT, %WS_EX_WINDOWEDGE OR %WS_EX_CONTROLPARENT OR %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR, TO ghDlg
    CONTROL ADD "SysListView32", ghDlg, %lvwNames, "", 6, 6, 150, 207, %WS_CHILD OR %WS_DISABLED OR %WS_VISIBLE OR %WS_BORDER OR %WS_TABSTOP OR %LVS_REPORT OR %LVS_SHOWSELALWAYS OR %LVS_SINGLESEL, %WS_EX_CLIENTEDGE OR %WS_EX_LEFT OR _
      %WS_EX_RIGHTSCROLLBAR
    CONTROL ADD FRAME, ghDlg, %frameUserInformation, "User Information", 162, 3, 192, 60
    CONTROL ADD LABEL, ghDlg, %staticName, "Name:", 168, 21, 42, 10, %WS_CHILD OR %WS_VISIBLE OR %SS_LEFT OR %SS_CENTERIMAGE, %WS_EX_LEFT OR %WS_EX_LTRREADING
    CONTROL ADD TEXTBOX, ghDlg, %edtName, "", 210, 21, 135, 13, %WS_CHILD OR %WS_VISIBLE OR %ES_LEFT OR %ES_AUTOHSCROLL OR %ES_READONLY, %WS_EX_CLIENTEDGE OR %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR
    CONTROL ADD LABEL, ghDlg, %staticTotalPosts, "Total Posts:", 168, 42, 42, 12, %WS_CHILD OR %WS_VISIBLE OR %SS_LEFT OR %SS_CENTERIMAGE, %WS_EX_LEFT OR %WS_EX_LTRREADING
    CONTROL ADD TEXTBOX, ghDlg, %edtTotalPosts, "", 210, 42, 42, 13, %WS_CHILD OR %WS_VISIBLE OR %ES_LEFT OR %ES_AUTOHSCROLL OR %ES_READONLY, %WS_EX_CLIENTEDGE OR %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR
    CONTROL ADD LABEL, ghDlg, %staticIndex, "Index:", 276, 42, 27, 12, %WS_CHILD OR %WS_VISIBLE OR %SS_LEFT OR %SS_CENTERIMAGE, %WS_EX_LEFT OR %WS_EX_LTRREADING
    CONTROL ADD TEXTBOX, ghDlg, %edtIndex, "", 303, 42, 42, 13, %WS_CHILD OR %WS_VISIBLE OR %ES_LEFT OR %ES_AUTOHSCROLL OR %ES_READONLY, %WS_EX_CLIENTEDGE OR %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR
    CONTROL ADD FRAME, ghDlg, %frameDayOfWeekUsageGraph, "Day of Week Usage Graph", 162, 66, 192, 72
    CONTROL ADD FRAME, ghDlg, %frameTimeOfDayUsageGraph, "Time of Day Usage Graph", 162, 141, 192, 72
    CONTROL ADD LABEL, ghDlg, %staticStatus, "", 9, 222, 225, 15, %WS_CHILD OR %WS_VISIBLE OR %SS_LEFT OR %SS_CENTERIMAGE, %WS_EX_STATICEDGE OR %WS_EX_LEFT OR %WS_EX_LTRREADING
    CONTROL ADD BUTTON, ghDlg, %btnAnalyze, "&Analyze All", 249, 222, 48, 15, %WS_CHILD OR %WS_VISIBLE OR %WS_DISABLED OR %WS_TABSTOP OR %BS_TEXT OR %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, %WS_EX_LEFT OR %WS_EX_LTRREADING
    CONTROL ADD BUTTON, ghDlg, %btnExit, "E&xit", 306, 222, 48, 15
    DIALOG SHOW MODAL ghDlg, CALL dlgMainCallback TO lngResult
    FUNCTION = lngResult
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION GD2JD( lngYear AS LONG, lngMonth AS LONG, lngDay AS LONG ) AS LONG
    FUNCTION = lngDay - 32075 + 1461 * ( lngYear + 4800 + ( lngMonth - 14 ) / 12 ) / 4 + 367 * _
      ( lngMonth - 2 - ( lngMonth - 14 ) / 12 * 12 ) / 12 - 3 * (( lngYear + 4900 + ( lngMonth - 14 ) / 12 ) / 100 ) / 4
END FUNCTION

'----------------------------------------------------------------------------(')

SUB CvtDate( strDate AS STRING, lngDate AS LONG, lngTime AS LONG )
    LOCAL strMonths AS STRING
    LOCAL lngYear AS LONG
    LOCAL lngMonth AS LONG
    LOCAL lngDay AS LONG
    LOCAL lngHour AS LONG
    LOCAL lngMinute AS LONG
    strDate = UCASE$( strDate )
    REPLACE "," WITH "" IN strDate
    REPLACE ":" WITH " " IN strDate
    REPLACE " " WITH "," IN strDate
    strMonths = "JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC"
    lngYear = VAL( PARSE$( strDate, 3 ))
    lngMonth = (( INSTR( strMonths, LEFT$( PARSE$( strDate, 1 ), 3 )) - 1 ) / 3 ) + 1
    lngDay = VAL( PARSE$( strDate, 2 ))
    lngDate = GD2JD( lngYear, lngMonth, lngDay )
    lngHour = VAL( PARSE$( strDate, 4 ))
    lngMinute = VAL( PARSE$( strDate, 5 ))
    IF PARSE$( strDate, 6 ) = "AM" THEN
        IF lngHour = 12 THEN lngHour = 0
    ELSE
        IF lngHour < 12 THEN lngHour = lngHour + 12
    END IF
    lngTime = lngHour * 60 + lngMinute
END SUB

'----------------------------------------------------------------------------(')

SUB AddToArray( strName AS STRING, lngDate AS LONG, lngTime AS LONG )
    LOCAL lngPos AS LONG
    IF strName = "" OR lngDate = 0 OR lngTime = 0 THEN EXIT SUB
    INCR glngArrayIndex
    IF glngArrayIndex > UBOUND( gudtPostingArray ) THEN
        REDIM PRESERVE gudtPostingArray( glngArrayIndex + 500 )
    END IF
    lngPos = INSTR( - 1, strName, "," )
    gudtPostingArray( glngArrayIndex ).strName = MCASE$( TRIM$( LEFT$( strName, lngPos - 1 )))
    gudtPostingArray( glngArrayIndex ).lngDate = lngDate
    gudtPostingArray( glngArrayIndex ).lngTime = lngTime
END SUB

'----------------------------------------------------------------------------(')

FUNCTION ProcessFiles( BYVAL lngDummy AS LONG ) AS LONG
    LOCAL hFileIn AS DWORD
    LOCAL hFileOut AS DWORD
    LOCAL strName AS STRING
    LOCAL strBuffer AS STRING
    LOCAL strSourceLine AS STRING
    LOCAL lngCounter AS LONG
    LOCAL lngDate AS LONG
    LOCAL lngTime AS LONG
    IF DIR$( ENVIRON$( $EnvironToCheck ) & $TempFileName ) <> "" THEN KILL ENVIRON$( $EnvironToCheck ) & $TempFileName
    glngArrayIndex = - 1
    gstrForumFile = DIR$( PoffsSourceDir$ & "*.dat" )
    DO UNTIL gstrForumFile = ""
        DIALOG SEND ghDlg, %WM_USER + 2, 0, 0
        hFileIn = FREEFILE
        OPEN PoffsSourceDir$ & gstrForumFile FOR BINARY AS #hFileIn
        hFileOut = FREEFILE
        OPEN ENVIRON$( $EnvironToCheck ) & $TempFileName FOR BINARY AS #hFileOut
        GET$ #hFileIn, LOF( hFileIn ), strBuffer
        DIALOG DOEVENTS
        SLEEP 1
        REPLACE CHR$( 10 ) WITH CHR$( 13 ) IN strBuffer
        IF gboolExitFlag = %TRUE THEN
            CLOSE #hFileIn, #hFileOut
            KILL ENVIRON$( $EnvironToCheck ) & $TempFileName
            EXIT FUNCTION
        END IF
        PUT$ #hFileOut, strBuffer
        CLOSE #hFileIn, #hFileOut
        hFileIn = FREEFILE
        OPEN ENVIRON$( $EnvironToCheck ) & $TempFileName FOR INPUT AS #hFileIn
        DO UNTIL EOF( hFileIn )
            IF ( lngCounter MOD 5000 ) = 0 THEN
                DIALOG SEND ghDlg, %WM_USER + 2, 1, 0
                DIALOG DOEVENTS
                SLEEP 1
                IF gboolExitFlag = %TRUE THEN
                    CLOSE #hFileIn
                    KILL ENVIRON$( $EnvironToCheck ) & $TempFileName
                    EXIT FUNCTION
                END IF
            END IF
            INCR lngCounter
            LINE INPUT #hFileIn, strSourceLine
            IF LEFT$( strSourceLine, 9 ) = "'TOPIC:  " THEN
                IF ISFALSE( EOF( hFileIn )) THEN LINE INPUT #hFileIn, strSourceLine
                strName = TRIM$( MID$( strSourceLine, 10 ))
                IF ISFALSE( EOF( hFileIn )) THEN LINE INPUT #hFileIn, strSourceLine
                CALL CvtDate( TRIM$( MID$( strSourceLine, 10 )), lngDate, lngTime )
                CALL AddToArray( strName, lngDate, lngTime )
                strName = ""
                lngDate = 0
                lngTime = 0
                ITERATE
            END IF
            IF LEFT$( strSourceLine, 10 ) = "'############################ REPLY ############################" THEN
                IF ISFALSE( EOF( hFileIn )) THEN LINE INPUT #hFileIn, strSourceLine
                strName = TRIM$( MID$( strSourceLine, 2 ))
                IF ISFALSE( EOF( hFileIn )) THEN LINE INPUT #hFileIn, strSourceLine
                CALL CvtDate( TRIM$( MID$( strSourceLine, 8 )), lngDate, lngTime )
                CALL AddToArray( strName, lngDate, lngTime )
                strName = ""
                lngDate = 0
                lngTime = 0
            END IF
        LOOP
        CLOSE #hFileIn
        gstrForumFile = DIR$
        KILL ENVIRON$( $EnvironToCheck ) & $TempFileName
    LOOP
    REDIM PRESERVE gudtPostingArray( glngArrayIndex )
    ARRAY SORT gudtPostingArray( ), COLLATE UCASE
    DIALOG SEND ghDlg, %WM_USER + 1, 0, 0
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION LV_Compare( BYVAL lParam1 AS LONG, BYVAL lParam2 AS LONG, BYVAL lParamsort AS LONG ) AS INTEGER
    LOCAL udtLVFindInfo AS LV_FINDINFO
    LOCAL strString1 AS STRING
    LOCAL strString2 AS STRING
    LOCAL lngIndex AS LONG
    udtLVFindInfo.flags = %LVFI_PARAM
    udtLVFindInfo.lParam = lParam1
    lngIndex = ListView_FindItem( ghListview, - 1, udtLVFindInfo )
    strString1 = UCASE$( LV_ReadItem( lngIndex, lParamsort ))
    udtLVFindInfo.lParam = lParam2
    lngIndex = ListView_FindItem( ghListview, - 1, udtLVFindInfo )
    strString2 = UCASE$( LV_ReadItem( lngIndex, lParamsort ))
    IF lParamsort <> 0 THEN
        REPLACE "," WITH "" IN strString1
        REPLACE "," WITH "" IN strString2
        strString1 = FORMAT$( VAL( strString1 ), "000000000.00" )
        strString2 = FORMAT$( VAL( strString2 ), "000000000.00" )
    END IF
    SELECT CASE glngLVSortDirection
        CASE 0
            IF strString1 < strString2 THEN
                FUNCTION = - 1
            ELSEIF strString1 > strString2 THEN
                FUNCTION = 1
            ELSE
                FUNCTION = 0
            END IF
        CASE ELSE
            IF strString1 > strString2 THEN
                FUNCTION = - 1
            ELSEIF strString1 < strString2 THEN
                FUNCTION = 1
            ELSE
                FUNCTION = 0
            END IF
    END SELECT
END FUNCTION
